﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace SpawnFile
{
    public delegate void _Save(object sender,int idx, string Basename,string content);
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            this.Close();
        }
        private void save(object sender,int idx, string baseName,string content)
        {
            string path = tbOutputPath.Text + "\\" + baseName;
            try
            {
                int tmplen =5- idx.ToString().Length;
                string tmpstr = idx.ToString();
                for (int i = 0; i < tmplen; i++)
                {
                    tmpstr = "0" + tmpstr;
                }
                path += tmpstr;
            }
            catch (Exception)
            {
            }
            path += ".txt";
            Stream stream = File.Create(path);
            stream.Close();
            stream = File.OpenWrite(path);
            StreamWriter streamWriter=new StreamWriter(stream);
            streamWriter.Write(content);
            streamWriter.Close();
            stream.Close();
        }
        private void btnStart_Click(object sender, EventArgs e)
        {
            if(tbBaseName.Text!="" && tbDelimiter.Text!="" && tbInputFile.Text!="" && tbOutputPath.Text!="")
            {
                Stream stream = File.OpenRead(tbInputFile.Text);
                StreamReader streamReader=new StreamReader(stream);
                string content = streamReader.ReadToEnd();
                Spawn spawn = new Spawn();
                spawn.Basename = tbBaseName.Text;
                spawn.delimiter = tbDelimiter.Text[0];
                spawn.text = content;
                spawn.save += new _Save(save);
                if (cbDelimiter.Checked)
                {
                    spawn.compress = true;
                }
                else
                {
                    spawn.compress = false;
                }
                spawn.Process();
                MessageBox.Show("complete");
            }
        }

        private void btnLoadInpFile_Click(object sender, EventArgs e)
        {
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.Filter = "txt files (*.txt)|*.txt";
            if (openFileDialog.ShowDialog() == DialogResult.OK)
            {
                tbInputFile.Text = openFileDialog.FileName;
            }
        }

        private void btnOutputFolder_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog folder=new FolderBrowserDialog();
            if (folder.ShowDialog()==DialogResult.OK)
            {
                tbOutputPath.Text = folder.SelectedPath;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cbDelimiter.Checked = true;
        }
    }
}
