﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SpawnFile
{
    class Spawn
    {
        public string text;
        public char delimiter;
        public bool compress;
        public event _Save save;
        public string Basename;
        public bool Process()
        {
            bool tmp = true;
            if (text!="")
            {
                long length = text.Length;
                string tmptxt = "";
                int idx = 0;
                if (compress)
                {
                    for (int i = 0; i < length; i++)
                    {
                        if (text[i]!=delimiter)
                        {
                            tmptxt += text[i];
                        }
                        else
                        {
                            if (tmptxt!="")
                            {
                                if (save!=null)
                                {
                                    save(this, idx, Basename, tmptxt);
                                    idx++;
                                    tmptxt = "";
                                }
                            }
                        }
                    }    
                }
                else
                {
                    for (int i = 0; i < length; i++)
                    {
                        if (text[i] != delimiter)
                        {
                            tmptxt += text[i];
                        }
                        else
                        {
                            if (save != null)
                            {
                                save(this, idx, Basename, tmptxt);
                                idx++;
                                tmptxt = "";
                            }
                        }
                    }
                }
                if (save != null && tmptxt!="")
                {
                    save(this, idx, Basename, tmptxt);
                }
            }
            return tmp;
        }
    }
}
